require 'sketchup.rb'

def triangulateSelected( all = false)
  # get the active model
  model = Sketchup.active_model
  #get currently selected objects
  selection_set = model.selection

  if all
    # loop through all the selected faces, and triangulate them
    selection_set.each {|entity|
        if entity.typename == "Face"
          # get all the vertices for the current face
          vertices = entity.vertices
          # find the centroid of the face
          geomcen = entity.bounds.center 
          # insert the edges
          vertices.each {|vert| edge = model.active_entities.add_edges geomcen,vert }
        end
    }
  else
    # loop through all the selected faces, and triangulate them
    selection_set.each {|entity|
        if entity.typename == "Face" && entity.vertices.length != 3
          # get all the vertices for the current face
          vertices = entity.vertices
          # find the centroid of the face
          geomcen = entity.bounds.center 
          # insert the edges
          vertices.each {|vert| edge = model.active_entities.add_edges geomcen,vert }
        end
    }
  end
end # end triangulateSelected

if( not file_loaded?("triangulateSelected.rb") )

    add_separator_to_menu("Plugins")
    UI.menu("Plugins").add_item("triangulateSelected") { triangulateSelected }

end

#-----------------------------------------------------------------------------
file_loaded("triangulateSelected.rb")

